#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <signal.h>
#include <sys/wait.h>
#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif
#include "toolbar.p.h"

typedef struct _node_info Node_Info;

struct _node_info
{
   int on;   
   int emp;
   int va1k;
   int vasenet;
   int sbt2;
   int quanta;
   int unknown;
};

GtkWidget *base = NULL;

void new_node_type(Node *nd);
void on_on_button_clicked                (GtkButton       *button, gpointer         user_data);
void on_off_button_clicked                (GtkButton       *button, gpointer         user_data);
void on_cycle_button_clicked                (GtkButton       *button, gpointer         user_data);
void on_identify_button_clicked                (GtkButton       *button, gpointer         user_data);
void on_identify_off_button_clicked                (GtkButton       *button, gpointer         user_data);
GtkWidget *create_base(void);
GtkWidget *create_pixmap(GtkWidget *w, char *pixmap);
void add_pixmap_directory (char *dir);

void
new_node_type(Node *nd)
{
   Nexxus *nx;
   Node_Info *in;
   
   nx = nd->nexxus;
   in = nd->data;
   
   flim_client_block_messages();
   /* figure out the node type */
     {
	gchar buf[4096];
	
	if (!in->emp)
	  {
	     g_snprintf(buf, sizeof(buf), "EMP:NODE_STATUS:%s", nd->name);
	     FLIM_COMMS_BEGIN(nx->connection, buf);
	     if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT >= 0))
	       {
		  while (FLIM_COMMS_REPLY)
		    {
		       if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			 {
			    in->emp = 1;
			    break;
			 }
		       if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			  break;
		       if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
			  break;
		       FILM_COMMS_GET_REPLY;
		    }
	       }
	     else
		in->emp = 0;
	     FILM_COMMS_REPLY_END;
	  }
	if (!in->emp)
	  {
	     g_snprintf(buf, sizeof(buf), "va1000:chassis_status:%s", nd->name);
	     FLIM_COMMS_BEGIN(nx->connection, buf);
	     if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT >= 0))
	       {
		  while (FLIM_COMMS_REPLY)
		    {
		       if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			 {
			    in->va1k = 1;
			    break;
			 }
		       if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			  break;
		       if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
			 break;
		       FILM_COMMS_GET_REPLY;
		    }
	       }
	     else
	       in->va1k = 0;
	     FILM_COMMS_REPLY_END;
	     if (!in->va1k)
	       {
		  g_snprintf(buf, sizeof(buf), "vasenet:chassis_status:%s", nd->name);
		  FLIM_COMMS_BEGIN(nx->connection, buf);
		  if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT >= 0))
		    {
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			      {
				 in->vasenet = 1;
				 break;
			      }
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			      break;
			    if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
			      break;
			    FILM_COMMS_GET_REPLY;
			 }
		    }
		  else
		    in->vasenet = 0;
		  FILM_COMMS_REPLY_END;
		  if (!in->vasenet)
		    {
		       g_snprintf(buf, sizeof(buf), "sbt2:chassis_status:%s", nd->name);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT >= 0))
			 {
			    while (FLIM_COMMS_REPLY)
			      {
				 if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
				   {
				      in->sbt2 = 1;
				      break;
				   }
				 if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
				   break;
				 if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
				   break;
				 FILM_COMMS_GET_REPLY;
			      }
			 }
		       else
			 in->sbt2 = 0;
		       FILM_COMMS_REPLY_END;
		       if (!in->sbt2)
			 {
			    g_snprintf(buf, sizeof(buf), "quanta:chassis_status:%s", nd->name);
			    FLIM_COMMS_BEGIN(nx->connection, buf);
			    if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT >= 0))
			      {
				 while (FLIM_COMMS_REPLY)
				   {
				      if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
					{
					   in->quanta = 1;
					   break;
					}
				      if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
					break;
				      if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
					break;
				      FILM_COMMS_GET_REPLY;
				   }
			      }
			    else
			      in->quanta = 0;
			    FILM_COMMS_REPLY_END;
			    if (!in->quanta)
			      in->unknown = 1;
			 }
		    }
	       }
	  }
     }
   flim_client_unblock_messages();
}

void
flim_client_message(Msg *msg)
{
   if (!strcmp(msg->msg, "nexxus_add"))
     {
	Nexxus *nx;
	char nx_name[4096], nx_address[4096], nx_login[4096], nx_password[4096];
	
	nx = nexxus_new();
	nx_login[0] = 0;
	nx_password[0] = 0;
	sscanf(msg->dat, "%[^:]:%[^:]:%[^:]:%[^:]", nx_name, nx_address, nx_login, nx_password);
	nx->name = g_strdup(nx_name);
	nx->address = g_strdup(nx_address);
	nx->login = g_strdup(nx_login);
	nx->password = g_strdup(nx_password);
	nexxus_connect(nx);
     }
   else if (!strcmp(msg->msg, "nexxus_del"))
     {
	Nexxus *nx;
	
	nx = nexxus_find(msg->dat);
	if (nx) 
	  {
	     nexxus_free(nx);
	  }
     }
   else if (!strcmp(msg->msg, "nexxus_rename"))
     {
	Nexxus *nx;
	char nx_name[4096], nx_name2[4096];
	
	sscanf(msg->dat, "%[^:]:%[^:]", nx_name, nx_name2);
	nx = nexxus_find(nx_name);
	if (nx)
	  {
	     if (nx->name) g_free(nx->name);
	     nx->name = g_strdup(nx_name2);
	  }
     }
   else if (!strcmp(msg->msg, "nexxus_address"))
     {
	Nexxus *nx;
	char nx_name[4096], nx_addr[4096];
	
	sscanf(msg->dat, "%[^:]:%[^:]", nx_name, nx_addr);
	nx = nexxus_find(nx_name);
	if (nx)
	  {
	     if (nx->address) g_free(nx->address);
	     nx->address = g_strdup(nx_addr);
	     if (nx->connection) flim_comms_disconnect_nexxus(nx->connection);
	     nx->connection = NULL;
	     nexxus_connect(nx);
	  }
     }
   else if (!strcmp(msg->msg, "node_add"))
     {
	Nexxus *nx;
	Node *nd;
	char nx_name[4096], nd_name[4096];
	
	sscanf(msg->dat, "%[^:]:%[^:]", nx_name, nd_name);
	nx = nexxus_find(nx_name);
	if (nx)
	  {
	     Node_Info *ni;
	     
	     nd = node_new(nx);
	     nd->name = g_strdup(nd_name);
	     ni = g_malloc(sizeof(Node_Info));
	     ni->on = 0;
	     ni->emp = 0;
	     ni->va1k = 0;
	     ni->vasenet = 0;
	     ni->sbt2 = 0;
	     ni->quanta = 0;
	     ni->unknown = 0;
	     nd->data = ni;
	     new_node_type(nd);
	  }
     }
   else if (!strcmp(msg->msg, "node_del"))
     {
	Node *nd;
	
	nd = node_find(msg->dat);
	if (nd)
	  {
	     Node_Info *ni;
	     
	     ni = nd->data;
	     g_free(ni);
	     node_free(nd);
	  }
     }
   else if (!strcmp(msg->msg, "node_rename"))
     {
	Node *nd;
	char nx_name[4096], nd_name[4096], nd_name2[4096], buf[4096];
	
	sscanf(msg->dat, "%[^:]:%[^:]:%[^:]", nx_name, nd_name, nd_name2);
	g_snprintf(buf, sizeof(buf), "%s:%s", nx_name, nd_name);
	nd = node_find(buf);
	if (nd)
	  {
             if (nd->name) g_free(nd->name);
	     nd->name = g_strdup(nd_name2);	     
	  }
     }
   else if (!strcmp(msg->msg, "nexxus_select"))
     {
	Nexxus *nx;

	nx = nexxus_find(msg->dat);
	if (nx) 
	   {
	      nx->selected = 1;
	   }
     }
   else if (!strcmp(msg->msg, "node_select"))
     {
	Node *nd;

	nd = node_find(msg->dat);
	if (nd) 
	  {
	     nd->selected = 1;
	  }
     }
   else if (!strcmp(msg->msg, "nexxus_unselect"))
     {
	Nexxus *nx;

	nx = nexxus_find(msg->dat);
	if (nx) 
	  {
	     nx->selected = 0;
	  }
     }
   else if (!strcmp(msg->msg, "node_unselect"))
     {
	Node *nd;

	nd = node_find(msg->dat);
	if (nd) 
	  {
	     nd->selected = 0;
	  }
     }
}

void
on_on_button_clicked                (GtkButton       *button,
				     gpointer         user_data)
{
   GList *l;
   
   for (l = nexxus_list; l; l = l->next)
     {
	Nexxus *nx;
	GList *ll;
	
	nx = l->data;
	for (ll = nx->nodes; ll; ll = ll->next)
	  {
	     Node *nd;
	     
	     nd = ll->data;
	     if (nd->selected)
	       {
		  char buf[4096];
		  
		  if (((Node_Info *)(nd->data))->emp)
		     g_snprintf(buf, sizeof(buf), "emp:power_on:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->va1k)
		     g_snprintf(buf, sizeof(buf), "va1000:power_on:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->vasenet)
		     g_snprintf(buf, sizeof(buf), "vasenet:power_on:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->sbt2)
		     g_snprintf(buf, sizeof(buf), "sbt2:power_on:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->quanta)
		     g_snprintf(buf, sizeof(buf), "quanta:power_on:%s", nd->name);
		  else goto error;
		  FLIM_COMMS_BEGIN(nx->connection, buf);
		  while (FLIM_COMMS_REPLY)
		    {
		       if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			  break;
		       if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			  break;
		       FILM_COMMS_GET_REPLY;
		    }
		  FILM_COMMS_REPLY_END;
		  error: ;
	       }
	  }
     }
   button = NULL;
   user_data = NULL;
}
	
void
on_off_button_clicked                (GtkButton       *button,
				      gpointer         user_data)
{
   GList *l;
   
   for (l = nexxus_list; l; l = l->next)
     {
	Nexxus *nx;
	GList *ll;
	
	nx = l->data;
	for (ll = nx->nodes; ll; ll = ll->next)
	  {
	     Node *nd;
	     
	     nd = ll->data;
	     if (nd->selected)
	       {
		  char buf[4096];
		  
		  if (((Node_Info *)(nd->data))->emp)
		     g_snprintf(buf, sizeof(buf), "emp:power_off:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->va1k)
		     g_snprintf(buf, sizeof(buf), "va1000:power_off:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->vasenet)
		     g_snprintf(buf, sizeof(buf), "vasenet:power_off:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->sbt2)
		     g_snprintf(buf, sizeof(buf), "sbt2:power_off:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->quanta)
		     g_snprintf(buf, sizeof(buf), "quanta:power_off:%s", nd->name);
		  else goto error;
		  FLIM_COMMS_BEGIN(nx->connection, buf);
		  while (FLIM_COMMS_REPLY)
		    {
		       if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			  break;
		       if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			  break;
		       FILM_COMMS_GET_REPLY;
		    }
		  FILM_COMMS_REPLY_END;
		  error: ;
	       }
	  }
     }
   button = NULL;
   user_data = NULL;
}

void
on_cycle_button_clicked                (GtkButton       *button,
					gpointer         user_data)
{
   GList *l;
   
   for (l = nexxus_list; l; l = l->next)
     {
	Nexxus *nx;
	GList *ll;
	
	nx = l->data;
	for (ll = nx->nodes; ll; ll = ll->next)
	  {
	     Node *nd;
	     
	     nd = ll->data;
	     if (nd->selected)
	       {
		  char buf[4096];
		  
		  if (((Node_Info *)(nd->data))->emp)
		     g_snprintf(buf, sizeof(buf), "emp:power_cycle:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->va1k)
		     g_snprintf(buf, sizeof(buf), "va1000:power_cycle:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->vasenet)
		     g_snprintf(buf, sizeof(buf), "vasenet:power_off:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->sbt2)
		     g_snprintf(buf, sizeof(buf), "sbt2:hard_reset:%s", nd->name);
		  else if (((Node_Info *)(nd->data))->quanta)
		     g_snprintf(buf, sizeof(buf), "quanta:hard_reset:%s", nd->name);
		  else goto error;
		  FLIM_COMMS_BEGIN(nx->connection, buf);
		  while (FLIM_COMMS_REPLY)
		    {
		       if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			  break;
		       if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			  break;
		       FILM_COMMS_GET_REPLY;
		    }
		  FILM_COMMS_REPLY_END;
		  error:
		  if (((Node_Info *)(nd->data))->vasenet)
		    {
		       g_snprintf(buf, sizeof(buf), "vasenet:power_on:%s", nd->name);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			      break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			      break;
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;
		    }
	       }
	  }
     }
   button = NULL;
   user_data = NULL;
}

void
on_identify_button_clicked                (GtkButton       *button,
					   gpointer         user_data)
{
   GList *l;
   
   for (l = nexxus_list; l; l = l->next)
     {
	Nexxus *nx;
	GList *ll;
	
	nx = l->data;
	for (ll = nx->nodes; ll; ll = ll->next)
	  {
	     Node *nd;
	     
	     nd = ll->data;
	     if (nd->selected)
	       {
		  char buf[4096];
		  
		  if (((Node_Info *)(nd->data))->emp)
		     g_snprintf(buf, sizeof(buf), "emp:identify:%s:on", nd->name);
		  else if (((Node_Info *)(nd->data))->va1k)
		     g_snprintf(buf, sizeof(buf), "va1000:identify:%s:on", nd->name);
		  else if (((Node_Info *)(nd->data))->vasenet)
		     g_snprintf(buf, sizeof(buf), "vasenet:identify:%s", nd->name);
		  else goto error;
		  FLIM_COMMS_BEGIN(nx->connection, buf);
		  while (FLIM_COMMS_REPLY)
		    {
		       if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			  break;
		       if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			  break;
		       FILM_COMMS_GET_REPLY;
		    }
		  FILM_COMMS_REPLY_END;
		  error: ;
	       }
	  }
     }
   button = NULL;
   user_data = NULL;
}

void
on_identify_off_button_clicked                (GtkButton       *button,
					       gpointer         user_data)
{
   GList *l;
   
   for (l = nexxus_list; l; l = l->next)
     {
	Nexxus *nx;
	GList *ll;
	
	nx = l->data;
	for (ll = nx->nodes; ll; ll = ll->next)
	  {
	     Node *nd;
	     
	     nd = ll->data;
	     if (nd->selected)
	       {
		  char buf[4096];
		  
		  if (((Node_Info *)(nd->data))->emp)
		     g_snprintf(buf, sizeof(buf), "emp:identify:%s:off", nd->name);
		  else if (((Node_Info *)(nd->data))->va1k)
		     g_snprintf(buf, sizeof(buf), "va1000:identify:%s:off", nd->name);
		  else if (((Node_Info *)(nd->data))->vasenet)
		     g_snprintf(buf, sizeof(buf), "vasenet:identify:%s", nd->name);
		  else goto error;
		  FLIM_COMMS_BEGIN(nx->connection, buf);
		  while (FLIM_COMMS_REPLY)
		    {
		       if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
			  break;
		       if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
			  break;
		       FILM_COMMS_GET_REPLY;
		    }
		  FILM_COMMS_REPLY_END;
		  error: ;
	       }
	  }
     }
   button = NULL;
   user_data = NULL;
}

GtkWidget *
create_base(void)
{
   GtkWidget *base;
   GtkWidget *vbox1;
   GtkWidget *button1;
   GtkWidget *pixmap1;
   GtkWidget *button2;
   GtkWidget *pixmap2;
   GtkWidget *button3;
   GtkWidget *pixmap3;
   GtkWidget *button4;
   GtkWidget *pixmap4;
   GtkWidget *button5;
   GtkWidget *pixmap5;
   
   base = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_object_set_data (GTK_OBJECT (base), "base", base);
   gtk_container_set_border_width (GTK_CONTAINER (base), 0);
   gtk_window_set_title (GTK_WINDOW (base), "Flim");
   gtk_window_set_wmclass (GTK_WINDOW (base), "Toolbar", "FLIM");
   
   vbox1 = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (vbox1);
   gtk_object_set_data_full (GTK_OBJECT (base), "vbox1", vbox1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (vbox1);
   gtk_container_add (GTK_CONTAINER (base), vbox1);
   
   button1 = gtk_button_new();
   gtk_widget_show(button1);
   gtk_box_pack_start (GTK_BOX (vbox1), button1, FALSE, FALSE, 0);
   gtk_object_set_data_full (GTK_OBJECT (base), "on", button1,
			     (GtkDestroyNotify) gtk_widget_unref);

     {
	GtkTooltips *tt;
	
	tt = gtk_tooltips_new();
	gtk_tooltips_set_delay(GTK_TOOLTIPS(tt), 300);
	gtk_tooltips_enable(GTK_TOOLTIPS(tt));
	gtk_tooltips_set_tip(GTK_TOOLTIPS(tt), button1, 
			     _("Power selected nodes on")
			     , "");
     }
   
   pixmap1 = create_pixmap(base, "toolbar_on.xpm");
   gtk_widget_ref(pixmap1);
   gtk_object_set_data_full (GTK_OBJECT (base), "pixmap1", base,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (pixmap1);
   gtk_container_add (GTK_CONTAINER (button1), pixmap1);
   
   
   button2 = gtk_button_new();
   gtk_widget_show(button2);
   gtk_box_pack_start (GTK_BOX (vbox1), button2, FALSE, FALSE, 0);
   gtk_object_set_data_full (GTK_OBJECT (base), "off", button2,
			     (GtkDestroyNotify) gtk_widget_unref);

     {
	GtkTooltips *tt;
	
	tt = gtk_tooltips_new();
	gtk_tooltips_set_delay(GTK_TOOLTIPS(tt), 300);
	gtk_tooltips_enable(GTK_TOOLTIPS(tt));
	gtk_tooltips_set_tip(GTK_TOOLTIPS(tt), button2, 
			     _("Power selected nodes off")
			     , "");
     }
   
   pixmap2 = create_pixmap(base, "toolbar_off.xpm");
   gtk_widget_ref(pixmap2);
   gtk_object_set_data_full (GTK_OBJECT (base), "pixmap2", base,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (pixmap2);
   gtk_container_add (GTK_CONTAINER (button2), pixmap2);
   
   button3 = gtk_button_new();
   gtk_widget_show(button3);
   gtk_box_pack_start (GTK_BOX (vbox1), button3, FALSE, FALSE, 0);
   gtk_object_set_data_full (GTK_OBJECT (base), "cyc", button3,
			     (GtkDestroyNotify) gtk_widget_unref);

     {
	GtkTooltips *tt;
	
	tt = gtk_tooltips_new();
	gtk_tooltips_set_delay(GTK_TOOLTIPS(tt), 300);
	gtk_tooltips_enable(GTK_TOOLTIPS(tt));
	gtk_tooltips_set_tip(GTK_TOOLTIPS(tt), button3, 
			     _("Power cycle selected nodes")
			     , "");
     }
   
   pixmap3 = create_pixmap(base, "toolbar_cycle.xpm");
   gtk_widget_ref(pixmap3);
   gtk_object_set_data_full (GTK_OBJECT (base), "pixmap3", base,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (pixmap3);
   gtk_container_add (GTK_CONTAINER (button3), pixmap3);
   
   button4 = gtk_button_new();
   gtk_widget_show(button4);
   gtk_box_pack_start (GTK_BOX (vbox1), button4, FALSE, FALSE, 0);
   gtk_object_set_data_full (GTK_OBJECT (base), "id", button4,
			     (GtkDestroyNotify) gtk_widget_unref);

     {
	GtkTooltips *tt;
	
	tt = gtk_tooltips_new();
	gtk_tooltips_set_delay(GTK_TOOLTIPS(tt), 300);
	gtk_tooltips_enable(GTK_TOOLTIPS(tt));
	gtk_tooltips_set_tip(GTK_TOOLTIPS(tt), button4, 
			     _("Start identify on selected nodes")
			     , "");
     }
   
   pixmap4 = create_pixmap(base, "toolbar_id_on.xpm");
   gtk_widget_ref(pixmap4);
   gtk_object_set_data_full (GTK_OBJECT (base), "pixmap4", base,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (pixmap4);
   gtk_container_add (GTK_CONTAINER (button4), pixmap4);
   
   button5 = gtk_button_new();
   gtk_widget_show(button5);
   gtk_box_pack_start (GTK_BOX (vbox1), button5, FALSE, FALSE, 0);
   gtk_object_set_data_full (GTK_OBJECT (base), "id0", button5,
			     (GtkDestroyNotify) gtk_widget_unref);

     {
	GtkTooltips *tt;
	
	tt = gtk_tooltips_new();
	gtk_tooltips_set_delay(GTK_TOOLTIPS(tt), 300);
	gtk_tooltips_enable(GTK_TOOLTIPS(tt));
	gtk_tooltips_set_tip(GTK_TOOLTIPS(tt), button5, 
			     _("Stop identify on selected nodes")
			     , "");
     }
   
   pixmap5 = create_pixmap(base, "toolbar_id_off.xpm");
   gtk_widget_ref(pixmap5);
   gtk_object_set_data_full (GTK_OBJECT (base), "pixmap5", base,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (pixmap5);
   
   gtk_container_add (GTK_CONTAINER (button5), pixmap5);

   gtk_signal_connect (GTK_OBJECT (base), "destroy",
		       GTK_SIGNAL_FUNC (exit),
		       NULL);   
   gtk_signal_connect (GTK_OBJECT (button1), "clicked",
		       GTK_SIGNAL_FUNC (on_on_button_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (button2), "clicked",
		       GTK_SIGNAL_FUNC (on_off_button_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (button3), "clicked",
		       GTK_SIGNAL_FUNC (on_cycle_button_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (button4), "clicked",
		       GTK_SIGNAL_FUNC (on_identify_button_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (button5), "clicked",
		       GTK_SIGNAL_FUNC (on_identify_off_button_clicked),
		       NULL);
   
   return base;
}

int
main(int argc, char **argv)
{
   Msg msg;
   
   flim_comms_do_gui(0);
   flim_client_init(argc, argv);
#ifdef ENABLE_NLS
   bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
   textdomain (PACKAGE);
#endif
   
   gtk_set_locale ();
   gtk_init (&argc, &argv);
   
   add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
   add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");
   
   base = create_base();
   gtk_widget_realize(base);

   g_snprintf(msg.msg, sizeof(msg.msg), "is_toolbar");
   flim_client_send(&msg);   
   
   g_snprintf(msg.msg, sizeof(msg.msg), "window_id");
   g_snprintf(msg.dat, sizeof(msg.dat), "%i", (int)GDK_WINDOW_XWINDOW(base->window));
   flim_client_send(&msg);

   for (;;) { XEvent xev; if (XCheckTypedWindowEvent(GDK_WINDOW_XDISPLAY(base->window), GDK_WINDOW_XWINDOW(base->window), ReparentNotify, &xev)) break; usleep(100000); }
   gtk_widget_show(base);

   g_snprintf(msg.msg, sizeof(msg.msg), "ready");
   flim_client_send(&msg);
      
   gtk_main();
   return 0;
}
