#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <gtk/gtk.h>
#include <stdio.h>
#include <sys/socket.h>
#include <signal.h>
#include <netinet/in.h>
#include <sys/un.h>
#include <stdlib.h>
#include <sys/time.h>
#include <netdb.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <vacmclient_api.h>
#include "comms.h"
#include "support.h"

void *
flim_comms_connect_nexxus(char *address, char *error_ret, char *login, char *password)
{
   void *handle = NULL;
   
   if (!login)
     {
	login = "blum";
	password = "frub";
     }
   else if (strlen(login) < 1)
     {
	login = "blum";
	password = "frub";
     }
   if (api_nexxus_connect(address, login, password, &handle) < 0)
     {
	g_snprintf(error_ret, 1024, 
		   _("Error connecting to:\n%s\n%s"),
		   address, api_nexxus_get_error());
	return NULL;
     }
     {
	char **reply;
	int    reply_num;
	
	reply = flim_comms_get_reply(handle, &reply_num);
	if (reply)
	   flim_comms_free_reply(reply, reply_num);
     }
   return handle;
}

void
flim_comms_disconnect_nexxus(void *handle)
{
   api_nexxus_disconnect(handle);
}

void
flim_comms_send_msg(void *handle, char *message)
{
/*   printf("ask %s\n", message);*/
   api_nexxus_send_ipc(handle, message, strlen(message));
}

char **
flim_comms_get_reply(void *handle, int *ret_count)
{
   char        *buffer = NULL;
   __uint32_t   length;
   int          tries = 0, fields = 0, i, j;
   char       **reply = NULL, *c;
   
   while ((!buffer) && (tries < 160))
     {
	api_nexxus_wait_short_for_data(handle, &buffer, &length, 50000);
	while (gtk_events_pending()) gtk_main_iteration();
	tries++;
     }
   if (!buffer)
      return NULL;
/*   printf("comms ret buffer = %s\n", buffer);*/
   fields = 1;
   for (c = buffer; c < (buffer + length); c++)
     {
	if (*c == ':')
	   fields++;
     }
   reply = malloc(fields * sizeof(char *));
   for (i = 0, c = buffer; c < (buffer + length); c++)
     {
	char *marker;
	
	marker = c;
	/* count length of field */
	for (;(c < (buffer + length)) && (*c != ':'); c++);
	reply[i] = malloc(c - marker + 1);
	for (j = 0, c = marker;(c < (buffer + length)) && (*c != ':'); c++)
	   reply[i][j++] = *c;
	reply[i][j] = 0;
	i++;
     }
   free(buffer);
   *ret_count = fields;
   return reply;
}

void
flim_comms_free_reply(char **reply, int count)
{
   int i;
   
   for (i = 0; i < count; i++)
      free(reply[i]);
   free(reply);
}
