#ifndef NEXXUS_H
#define NEXXUS_H 1

typedef struct _nexxus Nexxus;
typedef struct _node Node;

struct _nexxus
{
   int    type;
   void  *connection;
   char  *name;
   char  *address;
   GList *nodes;
   char  *login;
   char  *password;
   
   int    selected;
};

struct _node
{
   int   type;
   char *name;
   char *address;
   char *device;
   char *password;
   char *asset_tag;
   
   char *id;
   int   state;

   Nexxus *nexxus;
   int    selected;
};

Nexxus *flim_nexxus_new(void);
Nexxus *flim_nexxus_find(char *name);
void    flim_nexxus_free(Nexxus *nx);
void    flim_nexxus_add(Nexxus *nx);
void    flim_nexxus_del(Nexxus *nx);
void    flim_nexxus_disconnect(Nexxus *nx);
void    flim_nexxus_connect(Nexxus *nx);
void    flim_nexxus_add_node(Nexxus *nx, Node *nd);
void    flim_nexxus_del_node(Nexxus *nx, Node *nd);
void    flim_nexxus_load_config(void);
void    flim_nexxus_save_config(void);
void    flim_nexxus_build_tree(GtkWidget *tree);
   
#endif
